# Uses of Class
org.apache.sysds.runtime.controlprogram.LocalVariableMap

Packages that use LocalVariableMap
Package
Description
org.apache.sysds.api.mlcontext
org.apache.sysds.hops
org.apache.sysds.hops.cost
org.apache.sysds.hops.fedplanner
org.apache.sysds.hops.recompile
org.apache.sysds.hops.rewrite
org.apache.sysds.runtime.controlprogram
org.apache.sysds.runtime.controlprogram.context
org.apache.sysds.runtime.controlprogram.paramserv
org.apache.sysds.runtime.controlprogram.parfor
org.apache.sysds.runtime.controlprogram.parfor.opt
org.apache.sysds.runtime.instructions.cp

## Uses of LocalVariableMap in org.apache.sysds.api.mlcontext

Methods in org.apache.sysds.api.mlcontext that return LocalVariableMap
Modifier and Type
Method
Description
`LocalVariableMap`
MLResults.`getSymbolTable()`
Obtain the symbol table, which is essentially a `Map<String, Data>` representing variables and their values as SystemDS representations.
`LocalVariableMap`
Script.`getSymbolTable()`
Obtain the symbol table, which is essentially a `HashMap<String, Data>` representing variables and their values.
Methods in org.apache.sysds.api.mlcontext with parameters of type LocalVariableMap
Modifier and Type
Method
Description
`static String`
MLContextUtil.`determineOutputTypeAsString(LocalVariableMap symbolTable, String outputName)`
Obtain a symbol table output type as a String
`static String`
MLContextUtil.`displayInputs(String name, Map<String,Object> map, LocalVariableMap symbolTable)`
Obtain a display of script inputs.
`static String`
MLContextUtil.`displayOutputs(String name, Set<String> outputNames, LocalVariableMap symbolTable)`
Obtain a display of the script outputs.
`static String`
MLContextUtil.`displayOutputs(Set<String> outputNames, LocalVariableMap symbolTable)`
Obtain a display of the script outputs.
`static String`
MLContextUtil.`displaySymbolTable(String name, LocalVariableMap symbolTable)`
Display the keys and values in the symbol table
`static String`
MLContextUtil.`displaySymbolTable(LocalVariableMap symbolTable)`
Display the keys and values in the symbol table
`static boolean`
MLContextUtil.`doesSymbolTableContainFrameObject(LocalVariableMap symbolTable, String variableName)`
Determine if the symbol table contains a FrameObject with the given variable name.
`static boolean`
MLContextUtil.`doesSymbolTableContainMatrixObject(LocalVariableMap symbolTable, String variableName)`
Determine if the symbol table contains a MatrixObject with the given variable name.
Constructors in org.apache.sysds.api.mlcontext with parameters of type LocalVariableMap
Modifier
Constructor
Description
``
`MLResults(LocalVariableMap symbolTable)`

## Uses of LocalVariableMap in org.apache.sysds.hops

Methods in org.apache.sysds.hops with parameters of type LocalVariableMap
Modifier and Type
Method
Description
`static double`
Hop.`computeBoundsInformation(Hop input, LocalVariableMap vars)`
`static double`
Hop.`computeBoundsInformation(Hop input, LocalVariableMap vars, Map<Long,Double> memo)`
`long`
Hop.`computeSizeInformation(Hop input, LocalVariableMap vars)`
`long`
Hop.`computeSizeInformation(Hop input, LocalVariableMap vars, Map<Long,Long> memo)`
`static long`
OptimizerUtils.`getNumIterations(ForProgramBlock fpb, LocalVariableMap vars, long defaultValue)`
`void`
Hop.`refreshColsParameterInformation(Hop input, LocalVariableMap vars)`
`void`
Hop.`refreshColsParameterInformation(Hop input, LocalVariableMap vars, Map<Long,Long> memo)`
`void`
Hop.`refreshRowsParameterInformation(Hop input, LocalVariableMap vars)`
`void`
Hop.`refreshRowsParameterInformation(Hop input, LocalVariableMap vars, Map<Long,Long> memo)`
`static double`
OptimizerUtils.`rEvalSimpleDoubleExpression(Hop root, Map<Long,Double> valMemo, LocalVariableMap vars)`
`static long`
OptimizerUtils.`rEvalSimpleLongExpression(Hop root, Map<Long,Long> valMemo, LocalVariableMap vars)`

## Uses of LocalVariableMap in org.apache.sysds.hops.cost

Methods in org.apache.sysds.hops.cost with parameters of type LocalVariableMap
Modifier and Type
Method
Description
`double`
CostEstimator.`getTimeEstimate(ProgramBlock pb, LocalVariableMap vars, HashMap<String,VarStats> stats, boolean recursive)`
`double`
CostEstimator.`getTimeEstimate(Program rtprog, LocalVariableMap vars, HashMap<String,VarStats> stats)`

## Uses of LocalVariableMap in org.apache.sysds.hops.fedplanner

Methods in org.apache.sysds.hops.fedplanner with parameters of type LocalVariableMap
Modifier and Type
Method
Description
`static ArrayList<Hop>`
FederatedPlannerUtils.`getTransientInputs(Hop currentHop, Map<String,Hop> paramMap, Map<String,Hop> transientWrites, LocalVariableMap localVariableMap)`
Get transient inputs from either paramMap or transientWrites.
`abstract void`
AFederatedPlanner.`rewriteFunctionDynamic(FunctionStatementBlock function, LocalVariableMap funcArgs)`
Selects a federated execution plan for the given function, taking into account federation types of the arguments.
`void`
FederatedPlannerFedAll.`rewriteFunctionDynamic(FunctionStatementBlock function, LocalVariableMap funcArgs)`
`void`
FederatedPlannerFedCostBased.`rewriteFunctionDynamic(FunctionStatementBlock function, LocalVariableMap funcArgs)`

## Uses of LocalVariableMap in org.apache.sysds.hops.recompile

Methods in org.apache.sysds.hops.recompile that return LocalVariableMap
Modifier and Type
Method
Description
`static LocalVariableMap`
Recompiler.`reconcileUpdatedCallVarsIf(LocalVariableMap oldCallVars, LocalVariableMap callVarsIf, LocalVariableMap callVarsElse, StatementBlock sb)`
Methods in org.apache.sysds.hops.recompile with parameters of type LocalVariableMap
Modifier and Type
Method
Description
`static void`
Recompiler.`extractDAGOutputStatistics(List<Hop> hops, LocalVariableMap vars)`
`static void`
Recompiler.`extractDAGOutputStatistics(List<Hop> hops, LocalVariableMap vars, boolean overwrite)`
`static void`
Recompiler.`extractDAGOutputStatistics(Hop hop, LocalVariableMap vars, boolean overwrite)`
`static ArrayList<Instruction>`
Recompiler.`recompileHopsDag(Hop hop, LocalVariableMap vars, RecompileStatus status, boolean inplace, boolean replaceLit, long tid)`
`static ArrayList<Instruction>`
Recompiler.`recompileHopsDag(StatementBlock sb, ArrayList<Hop> hops, LocalVariableMap vars, RecompileStatus status, boolean inplace, boolean replaceLit, long tid)`
`static void`
Recompiler.`recompileProgramBlockHierarchy(List<ProgramBlock> pbs, LocalVariableMap vars, long tid, boolean inplace, Recompiler.ResetType resetRecompile)`
`static LocalVariableMap`
Recompiler.`reconcileUpdatedCallVarsIf(LocalVariableMap oldCallVars, LocalVariableMap callVarsIf, LocalVariableMap callVarsElse, StatementBlock sb)`
`static boolean`
Recompiler.`reconcileUpdatedCallVarsLoops(LocalVariableMap oldCallVars, LocalVariableMap callVars, StatementBlock sb)`
`static void`
Recompiler.`removeUpdatedScalars(LocalVariableMap callVars, StatementBlock sb)`
Remove any scalar variables from the variable map if the variable is updated in this block.
`static void`
Recompiler.`rReplaceLiterals(Hop hop, LocalVariableMap vars, boolean scalarsOnly)`
`static void`
Recompiler.`rUpdateStatistics(Hop hop, LocalVariableMap vars)`

## Uses of LocalVariableMap in org.apache.sysds.hops.rewrite

Methods in org.apache.sysds.hops.rewrite that return LocalVariableMap
Modifier and Type
Method
Description
`LocalVariableMap`
ProgramRewriteStatus.`getVariables()`
Constructors in org.apache.sysds.hops.rewrite with parameters of type LocalVariableMap
Modifier
Constructor
Description
``
`ProgramRewriteStatus(LocalVariableMap vars)`
``
`RewriteRemovePersistentReadWrite(String[] in, String[] out, LocalVariableMap vars)`

## Uses of LocalVariableMap in org.apache.sysds.runtime.controlprogram

Methods in org.apache.sysds.runtime.controlprogram that return LocalVariableMap
Modifier and Type
Method
Description
`static LocalVariableMap`
LocalVariableMap.`deserialize(String varStr)`
Methods in org.apache.sysds.runtime.controlprogram with parameters of type LocalVariableMap
Modifier and Type
Method
Description
`void`
LocalVariableMap.`putAll(LocalVariableMap vars)`
Constructors in org.apache.sysds.runtime.controlprogram with parameters of type LocalVariableMap
Modifier
Constructor
Description
``
`LocalVariableMap(LocalVariableMap vars)`

## Uses of LocalVariableMap in org.apache.sysds.runtime.controlprogram.context

Methods in org.apache.sysds.runtime.controlprogram.context that return LocalVariableMap
Modifier and Type
Method
Description
`LocalVariableMap`
ExecutionContext.`getVariables()`
Methods in org.apache.sysds.runtime.controlprogram.context with parameters of type LocalVariableMap
Modifier and Type
Method
Description
`static ExecutionContext`
ExecutionContextFactory.`createContext(LocalVariableMap vars, Program prog)`
`void`
ExecutionContext.`setVariables(LocalVariableMap vars)`
Constructors in org.apache.sysds.runtime.controlprogram.context with parameters of type LocalVariableMap
Modifier
Constructor
Description
``
`ExecutionContext(LocalVariableMap vars)`

## Uses of LocalVariableMap in org.apache.sysds.runtime.controlprogram.paramserv

Methods in org.apache.sysds.runtime.controlprogram.paramserv with parameters of type LocalVariableMap
Modifier and Type
Method
Description
`static ExecutionContext`
ParamservUtils.`createExecutionContext(ExecutionContext ec, LocalVariableMap varsMap, String updFunc, String aggFunc, int k)`
`static ExecutionContext`
ParamservUtils.`createExecutionContext(ExecutionContext ec, LocalVariableMap varsMap, String updFunc, String aggFunc, int k, boolean forceExecTypeCP)`

## Uses of LocalVariableMap in org.apache.sysds.runtime.controlprogram.parfor

Methods in org.apache.sysds.runtime.controlprogram.parfor that return LocalVariableMap
Modifier and Type
Method
Description
`static LocalVariableMap[]`
RemoteParForUtils.`getResults(List<scala.Tuple2<Long,String>> out, org.apache.commons.logging.Log LOG)`
`LocalVariableMap`
ParForBody.`getVariables()`
`LocalVariableMap`
ParWorker.`getVariables()`
`LocalVariableMap[]`
RemoteParForJobReturn.`getVariables()`
Methods in org.apache.sysds.runtime.controlprogram.parfor with parameters of type LocalVariableMap
Modifier and Type
Method
Description
`static void`
RemoteParForUtils.`exportLineageItems(long workerID, LocalVariableMap vars, ArrayList<ParForStatementBlock.ResultVar> resultVars, Lineage lineage)`
Export lineage for remote Spark parfor workers.
`static ArrayList<String>`
RemoteParForUtils.`exportResultVariables(long workerID, LocalVariableMap vars, ArrayList<ParForStatementBlock.ResultVar> resultVars)`
For remote Spark parfor workers.
`static Lineage[]`
RemoteParForUtils.`getLineages(LocalVariableMap[] results)`
`void`
CachedReuseVariables.`reuseVariables(long pfid, LocalVariableMap vars, Collection<String> excludeList, Map<String,org.apache.spark.broadcast.Broadcast<CacheBlock<?>>> _brInputs, boolean cleanCache)`
Constructors in org.apache.sysds.runtime.controlprogram.parfor with parameters of type LocalVariableMap
Modifier
Constructor
Description
``
`RemoteParForJobReturn(boolean successful, int numTasks, int numIters, LocalVariableMap[] variables)`
``
`RemoteParForJobReturn(boolean successful, int numTasks, int numIters, LocalVariableMap[] variables, Lineage[] lineages)`

## Uses of LocalVariableMap in org.apache.sysds.runtime.controlprogram.parfor.opt

Methods in org.apache.sysds.runtime.controlprogram.parfor.opt that return LocalVariableMap
Modifier and Type
Method
Description
`static LocalVariableMap`
ProgramRecompiler.`getReusableScalarVariables(DMLProgram prog, StatementBlock parforSB, LocalVariableMap vars)`
Methods in org.apache.sysds.runtime.controlprogram.parfor.opt with parameters of type LocalVariableMap
Modifier and Type
Method
Description
`static ArrayList<OptNode>`
OptTreeConverter.`createAbstractOptNodes(ArrayList<Hop> hops, LocalVariableMap vars, OptTreePlanMapping hlMap, Set<String> memo)`
`static LocalVariableMap`
ProgramRecompiler.`getReusableScalarVariables(DMLProgram prog, StatementBlock parforSB, LocalVariableMap vars)`
`static OptNode`
OptTreeConverter.`rCreateAbstractOptNode(StatementBlock sb, ProgramBlock pb, LocalVariableMap vars, boolean topLevel, OptTreePlanMapping hlMap, Set<String> memo)`
`static List<OptNode>`
OptTreeConverter.`rCreateAbstractOptNodes(Hop hop, LocalVariableMap vars, OptTreePlanMapping hlMap, Set<String> memo)`
`static void`
ProgramRecompiler.`replaceConstantScalarVariables(StatementBlock sb, LocalVariableMap vars)`
Constructors in org.apache.sysds.runtime.controlprogram.parfor.opt with parameters of type LocalVariableMap
Modifier
Constructor
Description
``
`CostEstimatorRuntime(OptTreePlanMapping map, LocalVariableMap vars)`

## Uses of LocalVariableMap in org.apache.sysds.runtime.instructions.cp

Methods in org.apache.sysds.runtime.instructions.cp with parameters of type LocalVariableMap
Modifier and Type
Method
Description
`static String`
CPInstruction.`updateLabels(String instList, LocalVariableMap labelValueMapping)`
Takes a delimited string of instructions, and replaces ALL placeholder labels (such as ##mVar2## and ##Var5##) in ALL instructions.